'From Squeak2.7 of 5 January 2000 [latest update: #1762] on 19 March 2000 at 1:42:14 pm'!
AlignmentMorph subclass: #LaunchAlignmentMorph
	instanceVariableNames: 'window world '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic Documentation example'!
LaunchAlignmentMorph class
	instanceVariableNames: ''!
SimpleButtonMorph subclass: #LaunchButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic Documentation example'!
RectangleMorph subclass: #PathRectangleMorph
	instanceVariableNames: 'beginPoint finishRectangle counter increment path '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic Documentation example'!

!LaunchAlignmentMorph commentStamp: '<historical>' prior: 0!
I hold a group of buttons that are used to launch an application.!

!LaunchAlignmentMorph reorganize!
('anime2' animateWindowOpening:inWorld: doneAnimation openInWindowLabeled:inWorld:)
('anime1')
('initialization' initialize)
!


!LaunchAlignmentMorph methodsFor: 'anime2' stamp: 'jlb 3/15/2000 16:18'!
animateWindowOpening: theWindow inWorld: theWorld

	| topWindow anime |

	topWindow _ theWorld firstSubmorph.
	topWindow ifNotNil: [
		anime _ PathRectangleMorph beginPoint: ( topWindow bounds center ) finishRectangle: ( theWindow bounds).
		anime setProperty: #sender toValue: self.
		anime startStepping.
	 ]
	ifNil: [ self doneAnimation ].
! !

!LaunchAlignmentMorph methodsFor: 'anime2' stamp: 'jlb 3/15/2000 16:18'!
doneAnimation
	" add the world to the window "
	world addMorph: window.
	" and make the window the frontmost one "
	window activate.
	" Make sure that the submorphs are happening "
	world startSteppingSubmorphsOf: window.
	^window

! !

!LaunchAlignmentMorph methodsFor: 'anime2' stamp: 'jlb 3/15/2000 16:18'!
openInWindowLabeled: aString inWorld: theWorld

	| extent |

	inset _ 0.
	world _ theWorld.
	window _ (SystemWindow labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent _ self fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth.
	window extent: extent.
	self animateWindowOpening: window inWorld: theWorld.

! !

!LaunchAlignmentMorph methodsFor: 'initialization' stamp: 'jlb 3/15/2000 01:00'!
initialize
	| button |
	super initialize.
	orientation _ #vertical.
	button _ LaunchButtonMorph new 
				label: 'Browser' ;
				target: ( World activeHand ) ;
				actionSelector: #openBrowser ;
				actWhen: #buttonUp.
	self addMorph: button.
	button _ LaunchButtonMorph new 
				label: 'Workspace' ;
				target: ( World activeHand ) ;
				actionSelector: #openWorkspace ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	button _ LaunchButtonMorph new 
				label: 'Transcript' ;
				target: ( World activeHand ) ;
				actionSelector: #openTranscript ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	button _ LaunchButtonMorph new 
				label: 'Change Sorter' ;
				target: ( World activeHand ) ;
				actionSelector: #openChangeSorter: ;
				arguments: #( 1 ) ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	button _ LaunchButtonMorph new 
				label: 'File List' ;
				target: ( World activeHand ) ;
				actionSelector: #openFileList ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	self color: ( Color gray ).! !


!LaunchAlignmentMorph class reorganize!
('instance creation' openLauncher)
!


!LaunchAlignmentMorph class methodsFor: 'instance creation' stamp: 'jlb 3/15/2000 02:53'!
openLauncher
	^ self new openInWindowLabeled: 'Go' inWorld: World.! !


!LaunchButtonMorph commentStamp: '<historical>' prior: 0!
I am a button for a launch bar. !

!LaunchButtonMorph methodsFor: 'event handling' stamp: 'jlb 3/17/2000 13:12'!
mouseUp: evt
	| delay |
	" flash the button three times when the button is released"
	delay _ Delay forMilliseconds: 60.
	(self containsPoint: evt cursorPoint )
	ifTrue: [
		1 to: 3 do: [ :i |
			self color: oldColor.
			self refreshWorld.
			delay wait.
			self color: (oldColor mixed: 1/2 with: Color white).
			self refreshWorld.
			delay wait. ].
		].
	self color: oldColor.
	super mouseUp: evt.! !

!LaunchButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/15/2000 00:10'!
initialize
	super initialize.
	self useSquareCorners.
	bounds _ 0 @ 0 extent: 96 @ 20.
	self setDefaultLabel.
	self color: ( Color lightGray ).
	self borderColor: #raised.
	self borderWidth: 1.
! !

!LaunchButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/14/2000 23:46'!
label: aString

	| oldLabel m |
	(oldLabel _ self findA: StringMorph)
		ifNotNil: [oldLabel delete].
	m _ StringMorph contents: aString font: TextStyle defaultFont.
	" self extent: m extent + (borderWidth + 6). "
	m position: self center - (m extent // 2).
	self addMorph: m.
	m lock! !


!PathRectangleMorph commentStamp: '<historical>' prior: 0!
I am a path following Morph.

Given two rectangles, I calculate a path and then follow it.!

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/15/2000 12:29'!
beginPoint: thePoint finishRectangle: theRectangle
	beginPoint _ thePoint.
	finishRectangle _ theRectangle.
	self calculatePath.! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/16/2000 15:13'!
calculatePath
	|  pathRect pt1 pt2 pt3 pa pb k |
	
	pathRect _ beginPoint corner: ( finishRectangle topLeft ).
	pt1 _ beginPoint.
	pt2 _ pathRect topRight.
	pt3 _ finishRectangle topLeft.

	path _ Path new.
	path add: pt1.
	pa _ pt2 - pt1.
	pb _ pt3 - pt2.
	k _ 5 max: pa x abs + pa y abs + pb x abs + pb y abs // 20.
	"k is a guess as to how many line segments to use to approximate 
	the curve."
	k _ k/3.
	1 to: k do: 
		[:i | 
		path add: pa * i // k + pt1 * (k - i) + (pb * (i - 1) // k + pt2 * (i - 1)) // (k - 1)].
	path add: pt3.

	" Now calculate the amount to increment the rectangle when we grow"
	increment _ (  finishRectangle extent  - (8 @ 8) ) / ( path size * 2 ).
	increment _ increment max: ( 1 @ 1 ).
	increment _ increment rounded.

	self position: ( path at: 1 ).
! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/15/2000 12:57'!
initialize
	super initialize.
	self color: ( Color darkGray ).
	counter _ 1.
	self borderWidth: 0.
	self extent: ( 8 @ 8).! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/16/2000 17:13'!
reset
	" go back to where I started the animation at "
	counter _ 1.
	self extent: ( 8 @ 8).
	self position: beginPoint.
! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/15/2000 12:43'!
startStepping
	" add me to the world "
	World addMorphFront: self.
	super startStepping.! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/15/2000 16:06'!
step
	| rect1 |
	self position: ( path at: counter ).  
	rect1 _ self bounds expandBy: increment.
	self bounds: (rect1 origin extent: ( rect1 extent min: ( finishRectangle extent ))). 
	counter _ counter + 1.
	counter > ((path size) - 1) ifTrue: [ self stopStepping ].
	

! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/19/2000 13:42'!
stepTime
	" Everything, all the time "
	^ 0.! !

!PathRectangleMorph methodsFor: 'as yet unclassified' stamp: 'jlb 3/16/2000 17:14'!
stopStepping
	| sender |
	" delete removes me from the world that I entered when I started stepping "
	self delete.
	super stopStepping.
	self reset.
	" and tell my sender that I am done "
	sender _ self valueOfProperty: #sender.
	sender ifNotNil: [ sender doneAnimation].! !


!PathRectangleMorph class methodsFor: 'as yet unclassified' stamp: 'jlb 3/15/2000 12:29'!
beginPoint: thePoint finishRectangle: theRectangle
	^ self new beginPoint: thePoint finishRectangle: theRectangle.! !


