'From Squeak2.8alpha of 19 January 2000 [latest update: #1974] on 26 March 2000 at 10:00:01 am'!
SimpleButtonMorph subclass: #GradientButtonMorph
	instanceVariableNames: 'topColor bottomColor reverseFillStyle saveFill '
	classVariableNames: 'DelayTime '
	poolDictionaries: ''
	category: 'Morphic Documentation example'!

!GradientButtonMorph methodsFor: 'color' stamp: 'jlb 3/26/2000 09:34'!
cacheFillStyle
	| fill |
	"Make receiver use a solid fill style (e.g., a simple color)"
	fill _ GradientFillStyle ramp: {0.0 -> topColor. 1.0 -> bottomColor}.
	fill	origin: self topLeft ;
		direction: 0 @ self bounds extent y ;
		normal: self bounds extent x @ 0 ;
		radial: false.
	self fillStyle: fill.

	" reverse ramps the colors in the opposite direction "
	reverseFillStyle _ fill copy.
	reverseFillStyle colorRamp: {0.0 -> bottomColor. 1.0 -> topColor}.

! !

!GradientButtonMorph methodsFor: 'color' stamp: 'jlb 3/24/2000 15:38'!
gradientColor: theColor 

	topColor _ theColor.
	bottomColor _  (theColor mixed: 0.5 with: Color black).
	self cacheFillStyle.
	self changed.
! !

!GradientButtonMorph methodsFor: 'color' stamp: 'jlb 3/24/2000 15:38'!
gradientColor: color1 bottomColor: color2

	topColor _ color1.
	bottomColor _ color2.
	self cacheFillStyle.
	self changed.! !

!GradientButtonMorph methodsFor: 'color' stamp: 'jlb 3/24/2000 15:38'!
labelColor: theColor
	| sm |
	(sm _ self findA: StringMorph)
		ifNotNil: [sm color: theColor.].
! !


!GradientButtonMorph methodsFor: 'event handling' stamp: 'jlb 3/24/2000 17:29'!
mouseDown: evt
	self cacheFillStyle.
	saveFill _ self fillStyle.
	self fillStyle: reverseFillStyle.
	self changed.
	self refreshWorld.

! !

!GradientButtonMorph methodsFor: 'event handling' stamp: 'jlb 3/24/2000 16:26'!
mouseMove: evt 
	actWhen == #buttonDown ifTrue: [^ self].
	(self containsPoint: evt cursorPoint)
		ifTrue: 
			[self fillStyle = reverseFillStyle
				ifFalse: 
					[self fillStyle: reverseFillStyle.
					self changed.
					self world displayWorld].
			(actWhen == #whilePressed and: [evt anyButtonPressed])
				ifTrue: 
					[self doButtonAction.
					evt hand noteSignificantEvent: evt]]
		ifFalse: [self fillStyle = saveFill
				ifFalse: 
					[self fillStyle: saveFill.
					self changed.
					self world displayWorld]]! !

!GradientButtonMorph methodsFor: 'event handling' stamp: 'jlb 3/26/2000 08:40'!
mouseUp: evt 
	" flash the button three times when the button is released"
	| delay time elapsed |

	(self containsPoint: evt cursorPoint)
		ifTrue: [1 to: 3 do: 
				[:i | 
				time _ Time millisecondClockValue.
				self fillStyle: saveFill.
				self changed.
				self refreshWorld.
				elapsed _ Time millisecondClockValue - time.
				elapsed > 0
					ifTrue: 
						[delay _ Delay forMilliseconds: (elapsed min: DelayTime).
						delay wait].
				self fillStyle: reverseFillStyle.
				self changed.
				self refreshWorld.
				elapsed > 0
					ifTrue: 
						[delay wait]]].
	self fillStyle: saveFill.
	self changed.
	self refreshWorld.
	(actWhen == #buttonUp and: [self containsPoint: evt cursorPoint])
		ifTrue: [self doButtonAction]! !


!GradientButtonMorph methodsFor: 'geometry' stamp: 'jlb 3/24/2000 16:28'!
layoutChanged
	| sm |

	super layoutChanged.
	( sm _ self findA: StringMorph )
		ifNotNil: [ 	sm position: self center - (sm extent // 2). ].

	self cacheFillStyle.
! !

!GradientButtonMorph methodsFor: 'geometry' stamp: 'jlb 3/24/2000 16:59'!
position: thePoint	
	super position: thePoint.
	self cacheFillStyle.
! !


!GradientButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/24/2000 18:05'!
initialize

	super initialize.
	self useSquareCorners.
	bounds _ 0 @ 0 extent: 96 @ ( self class buttonHeight) .
	self setDefaultLabel.
	self borderColor: #raised.
	self borderWidth: 1.
	self useGradientFill.
	topColor _ Color lightGray.
	bottomColor _ Color black.
	self cacheFillStyle.


! !

!GradientButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/24/2000 13:41'!
label: aString

	| oldLabel m |
	(oldLabel _ self findA: StringMorph)
		ifNotNil: [oldLabel delete].
	m _ StringMorph contents: aString font: TextStyle defaultFont.
	m position: self center - (m extent // 2).
	self addMorph: m.
	m lock! !

!GradientButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/26/2000 09:50'!
setDefaultLabel
	self label: 'Untitled'.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GradientButtonMorph class
	instanceVariableNames: ''!

!GradientButtonMorph class methodsFor: 'class initialization' stamp: 'jlb 3/24/2000 17:47'!
initialize
	DelayTime _ 60.! !


!GradientButtonMorph class methodsFor: 'constants' stamp: 'jlb 3/24/2000 13:47'!
buttonHeight
	^ 22! !


GradientButtonMorph initialize!
