'From Squeak2.7 of 5 January 2000 [latest update: #1762] on 17 March 2000 at 2:49:37 pm'!
AlignmentMorph subclass: #LaunchAlignmentMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic Documentation example'!
LaunchAlignmentMorph class
	instanceVariableNames: ''!
SimpleButtonMorph subclass: #LaunchButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic Documentation example'!

!LaunchAlignmentMorph commentStamp: 'jlb 3/17/2000 13:11' prior: 0!
I hold a group of buttons that are used to open different types of Squeak windows.!

!LaunchAlignmentMorph methodsFor: 'initialization' stamp: 'jlb 3/15/2000 01:00'!
initialize
	| button |
	super initialize.
	orientation _ #vertical.
	button _ LaunchButtonMorph new 
				label: 'Browser' ;
				target: ( World activeHand ) ;
				actionSelector: #openBrowser ;
				actWhen: #buttonUp.
	self addMorph: button.
	button _ LaunchButtonMorph new 
				label: 'Workspace' ;
				target: ( World activeHand ) ;
				actionSelector: #openWorkspace ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	button _ LaunchButtonMorph new 
				label: 'Transcript' ;
				target: ( World activeHand ) ;
				actionSelector: #openTranscript ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	button _ LaunchButtonMorph new 
				label: 'Change Sorter' ;
				target: ( World activeHand ) ;
				actionSelector: #openChangeSorter: ;
				arguments: #( 1 ) ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	button _ LaunchButtonMorph new 
				label: 'File List' ;
				target: ( World activeHand ) ;
				actionSelector: #openFileList ;
				actWhen: #buttonUp.
	self addMorphBack: button.
	self color: ( Color gray ).! !


!LaunchAlignmentMorph class reorganize!
('instance creation' openLauncher)
!


!LaunchAlignmentMorph class methodsFor: 'instance creation' stamp: 'jlb 3/15/2000 02:53'!
openLauncher
	^ self new openInWindowLabeled: 'Go' inWorld: World.! !


!LaunchButtonMorph commentStamp: 'jlb 3/17/2000 13:44' prior: 0!
I am a button for a launch bar. !

!LaunchButtonMorph methodsFor: 'event handling' stamp: 'jlb 3/17/2000 13:12'!
mouseUp: evt
	| delay |
	" flash the button three times when the button is released"
	delay _ Delay forMilliseconds: 60.
	(self containsPoint: evt cursorPoint )
	ifTrue: [
		1 to: 3 do: [ :i |
			self color: oldColor.
			self refreshWorld.
			delay wait.
			self color: (oldColor mixed: 1/2 with: Color white).
			self refreshWorld.
			delay wait. ].
		].
	self color: oldColor.
	super mouseUp: evt.! !

!LaunchButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/15/2000 00:10'!
initialize
	super initialize.
	self useSquareCorners.
	bounds _ 0 @ 0 extent: 96 @ 20.
	self setDefaultLabel.
	self color: ( Color lightGray ).
	self borderColor: #raised.
	self borderWidth: 1.
! !

!LaunchButtonMorph methodsFor: 'initialize' stamp: 'jlb 3/14/2000 23:46'!
label: aString

	| oldLabel m |
	(oldLabel _ self findA: StringMorph)
		ifNotNil: [oldLabel delete].
	m _ StringMorph contents: aString font: TextStyle defaultFont.
	" self extent: m extent + (borderWidth + 6). "
	m position: self center - (m extent // 2).
	self addMorph: m.
	m lock! !


LaunchAlignmentMorph removeSelector: #animateWindowOpen:!
LaunchAlignmentMorph removeSelector: #openInWindowLabeled:inWorld:!
LaunchAlignmentMorph removeSelector: #animateRect:path:!
