'From Squeak2.7 of 5 January 2000 [latest update: #1762] on 18 February 2000 at 5:57:16 am'!
AlignmentMorph subclass: #CellofTableMorph
	instanceVariableNames: 'position object '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Table-Support'!
Object subclass: #Table
	instanceVariableNames: 'contents transposed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Table-Support'!
Table class
	instanceVariableNames: ''!
BorderedMorph subclass: #TableMorph
	instanceVariableNames: 'table inset padx pady centering minSize line layoutNeeded priorFullBounds rowGrid colGrid lineColor orientation openToDragNDrop '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Table-Support'!

!CellofTableMorph methodsFor: 'accessing' stamp: 'AK 2/4/2000 02:40'!
add: aObject

	submorphs addMorph: aObject.! !

!CellofTableMorph methodsFor: 'accessing' stamp: 'AK 2/4/2000 02:24'!
object
	^object! !

!CellofTableMorph methodsFor: 'accessing' stamp: 'AK 2/4/2000 02:24'!
object: aObject
	object _ aObject! !

!CellofTableMorph methodsFor: 'accessing' stamp: 'AK 2/4/2000 02:38'!
tabposition
	^position! !

!CellofTableMorph methodsFor: 'accessing' stamp: 'AK 2/4/2000 02:38'!
tabposition: aPoint
	position _ aPoint.! !


!CellofTableMorph class methodsFor: 'instance creation' stamp: 'AK 2/4/2000 02:35'!
object: anObject tabposition: aPoint

	^self new;
	add: anObject; 
	object: anObject; 
	tabposition: aPoint. ! !


!Table methodsFor: 'private' stamp: 'AK 2/10/2000 02:31'!
addContents: aCollection
		| orderedCollection  |
		(aCollection isKindOf: OrderedCollection) 
								ifTrue:[orderedCollection _ aCollection]
								ifFalse:[orderedCollection _ aCollection asOrderedCollection].
												
		self hasElement ifTrue:[self contents add: orderedCollection]
						ifFalse:[self contents at: 1 put: orderedCollection].! !

!Table methodsFor: 'private' stamp: 'AK 1/11/2000 02:08'!
addElements: aCollection 
	| colSize  diff |
	colSize _ self columnSize.
	diff _ aCollection size - self contents size.
	self contents size < aCollection size ifTrue:[ 1 to: diff do:[: i | i > diff ifFalse:[self contents add: OrderedCollection new]]].
									
	1 to: aCollection size do:[ :i | 
							(aCollection at: i) == nil ifFalse:[
								(self contents at: i) size < colSize ifTrue:[
											self at: (self transposedPoint: colSize@i) put: nil.
											(self contents at: i) add: (aCollection at: i)				
											]
											ifFalse:[ (self contents at: i) add: (aCollection at: i)]
								]]! !

!Table methodsFor: 'private' stamp: 'AK 2/8/2000 05:27'!
columnSize
		
		| max |
		max _ 0.
		self contents do: [:row | row size > max ifTrue: [max _ row size]].
		^max					   ! !

!Table methodsFor: 'private' stamp: 'AK 1/7/2000 02:09'!
isValidCell: aCell

	(aCell x > self numberOfColumns or: [ aCell y > self numberOfRows]) ifTrue: [^false]
																		ifFalse: [^true] ! !

!Table methodsFor: 'private' stamp: 'AK 1/9/2000 02:50'!
isValidRow: anInteger

	self isTransposed ifTrue:[anInteger > self columnSize ifTrue:[^false] ifFalse:[^true]]
					ifFalse:[(anInteger > self contents size) ifTrue: [^false] ifFalse: [^true] ]! !

!Table methodsFor: 'private' stamp: 'AK 1/9/2000 02:39'!
numberOfColumns
	"returns the number of columns in the receiver"
		
	self isTransposed ifTrue: [^self contents size]
					   ifFalse: [^self columnSize]
				
		! !

!Table methodsFor: 'private' stamp: 'AK 1/9/2000 02:39'!
numberOfRows
	"returns the number of rows in the receiver"
		
	self isTransposed ifFalse: [^self contents size]
					   ifTrue: [^self columnSize]! !

!Table methodsFor: 'private' stamp: 'AK 1/11/2000 01:26'!
transposedPoint: aPoint
	
	self isTransposed ifTrue:[^aPoint transposed] ifFalse:[^aPoint]! !

!Table methodsFor: 'romoving' stamp: 'AK 2/16/2000 21:35'!
cleanNil
	self contents do:[:r | 
		 [r isEmpty not and:[r last == nil]] whileTrue:[ r removeLast].
		 (self hasElement and:[r isEmpty]) ifTrue:[ contents remove: r]].! !

!Table methodsFor: 'romoving' stamp: 'AK 1/11/2000 02:48'!
removeCell: aPoint
	| truePoint x y |
	truePoint _ self transposedPoint: aPoint.
	x _ truePoint x.
	y _ truePoint y.
	(self isValidCell: aPoint) ifTrue:[x >(self contents at: y) size ifFalse:[(self contents at: y) removeAt: x]]
							ifFalse:[^' no cell exist']! !

!Table methodsFor: 'romoving' stamp: 'AK 1/11/2000 03:27'!
removeColumnAt: index

			self isTransposed ifTrue:[self contents removeAt: index]
			ifFalse:[ 1 to: self contents size do:[:i | self removeCell:(self transposedPoint: index@i) ]]! !

!Table methodsFor: 'romoving' stamp: 'AK 1/11/2000 03:13'!
removeColumnLast
		| colSize |
		colSize _ self columnSize.
		self isTransposed ifTrue:[self contents removeLast]
			ifFalse:[1 to: self contents size do:[:i | self removeCell:( self transposedPoint: colSize@i)]]
		! !

!Table methodsFor: 'romoving' stamp: 'AK 2/16/2000 21:35'!
removeObject: anObject
	
	self contents do:[:r |
				r doWithIndex:[:m :i | m == anObject ifTrue:[
								m == r last ifTrue:[r remove: anObject]
										   ifFalse:[r at: i put: nil]]
								].
				(self hasElement and:[r isEmpty]) ifTrue:[contents remove: r]].
	self cleanNil.! !

!Table methodsFor: 'romoving' stamp: 'AK 1/11/2000 03:26'!
removeRowAt: index
	
		self isTransposed ifTrue:[ 1 to: self contents size do:[:i | self removeCell:(self transposedPoint: index@i) ]]
			ifFalse:[self contents removeAt: index]! !

!Table methodsFor: 'romoving' stamp: 'AK 1/11/2000 03:08'!
removeRowLast
		| colSize |
		colSize _ self columnSize.
		self isTransposed ifTrue:[1 to: self contents size do:[:i | self removeCell:( self transposedPoint: colSize@i)]]
						ifFalse:[self contents removeLast]! !

!Table methodsFor: 'accessing' stamp: 'AK 1/10/2000 23:54'!
addColumn: aCollection

		self isTransposed ifTrue:[self addContents: aCollection]
						ifFalse:[self addElements: aCollection]! !

!Table methodsFor: 'accessing' stamp: 'AK 1/10/2000 23:52'!
addRow: aCollection

		self isTransposed ifTrue:[ self addElements: aCollection]
						ifFalse:[self addContents: aCollection]! !

!Table methodsFor: 'accessing' stamp: 'AK 1/11/2000 02:44'!
at: aPoint
	
	"returns the receivers contents at the given point
	 the points x value represents the column
	 the points y value represents the row
	"
	
	| truePoint row col |
	
	truePoint _ self transposedPoint: aPoint.
	row _ truePoint y.
	col _ truePoint x.
	(self isValidCell: aPoint) ifTrue: [ (col > (self contents at: row) size) ifTrue: [^nil]
										ifFalse: [^(self contents at: row) at: col]
										]
								ifFalse: [^' no cell exist']	! !

!Table methodsFor: 'accessing' stamp: 'AK 1/11/2000 01:27'!
at: aPoint put: aValue
	
	"returns the receivers contents at the given point
	 the points x value represents the column
	 the points y value represents the row
	"
	| truePoint row col colDiff theRow |
	truePoint _ self transposedPoint: aPoint.
	row _ truePoint y.
	col _ truePoint x.
	theRow _ self contents at: row.
				
	(self at: aPoint) == nil ifTrue:[
				colDiff _ col - theRow size.
				theRow size < col ifTrue:[ 1 to: colDiff do:[
											:i | i == colDiff ifTrue:[theRow add:  aValue]
													ifFalse:[theRow add: nil] ]
										]
								ifFalse:[ theRow at: col put: aValue]
				]
				ifFalse:[ theRow at: col put: aValue]! !

!Table methodsFor: 'accessing' stamp: 'AK 2/8/2000 06:34'!
columnAt: anIndex

		| col |
		self isTransposed ifFalse: [ col _ OrderedCollection new.
								1 to: self contents size do: 
									[: i | col add: (self at: anIndex@i)].
							  ^col]
					ifTrue: [^self contents at: anIndex]		! !

!Table methodsFor: 'accessing' stamp: 'AK 2/15/2000 05:44'!
columnPositionFor: anObject
	|  position |
	position _ self positionFor: anObject.
	^position x.	 
  
	
		! !

!Table methodsFor: 'accessing' stamp: 'AK 12/20/1999 23:13'!
contents
	"returns the contents of the receiver"
	
	^contents! !

!Table methodsFor: 'accessing' stamp: 'AK 12/20/1999 23:13'!
contents: aCollection
	"sets the receivers contents"
	
	contents _ aCollection
			! !

!Table methodsFor: 'accessing' stamp: 'AK 2/4/2000 04:54'!
hasElement
	| exist |
	exist _ false.
	contents do:[:row | row isEmpty ifFalse:[ exist _ true] ]. 
	^exist
				! !

!Table methodsFor: 'accessing' stamp: 'AK 1/7/2000 01:58'!
isTransposed
	^transposed == nil ifTrue: [transposed := false] ifFalse: [ transposed ]! !

!Table methodsFor: 'accessing' stamp: 'AK 2/15/2000 05:42'!
positionFor: anObject
	|  position |
	position _ 0@0.
	self contents doWithIndex:[:r :y | 
						r doWithIndex:[:c :x | c == anObject ifTrue:[ position _ x@y]]].
	^self transposedPoint: position.
		 
  
	
		! !

!Table methodsFor: 'accessing' stamp: 'AK 2/1/2000 03:11'!
rowAt: anIndex
	| rows |
	self isTransposed ifTrue: [  rows _ OrderedCollection new.
								1 to: self contents size do: 
									[: i | rows add: (self at: i@anIndex)].
							  ^rows]
					ifFalse: [^self contents at: anIndex]		! !

!Table methodsFor: 'accessing' stamp: 'AK 1/8/2000 02:40'!
rowAt: anIndex put: aRow

	(self isValidRow: anIndex) ifTrue:[
						self isTransposed ifTrue: [ 1 to: self contents size do: 
													[: i | self at: i@anIndex put: (aRow at: i)]
							  					]
										ifFalse: [self contents at: anIndex put: aRow]
							]
					ifFalse:[ ^'the row is not exist']		! !

!Table methodsFor: 'accessing' stamp: 'AK 2/15/2000 05:44'!
rowPositionFor: anObject
	|  position |
	position _ self positionFor: anObject.
	^position y.	 
  
	
		! !

!Table methodsFor: 'accessing' stamp: 'AK 12/21/1999 01:59'!
size
	"returns the receivers size as a Point"
	
	^ self numberOfColumns @ self numberOfRows! !

!Table methodsFor: 'accessing' stamp: 'AK 1/7/2000 01:58'!
transpose
	self transposed: self isTransposed not! !

!Table methodsFor: 'accessing' stamp: 'AK 1/7/2000 01:58'!
transposed: aBoolean
	
	aBoolean == self isTransposed ifTrue: [^self ]. 
	transposed := aBoolean.
	! !

!Table methodsFor: 'initialization' stamp: 'AK 1/19/2000 04:37'!
adaptArrayToTable: aArray columns: cInteger rows: rInteger

		" adapted a Array to two dimension list for the table structure including"
		| list row i next |
		i _ 1.
		next _ cInteger.
		list _ OrderedCollection new.
		
		1 to: rInteger do:[:index | row _ OrderedCollection new.  
					next <= aArray size ifTrue:[	
							(aArray copyFrom: i to: next) do:[:e | row add: e].
							i _ next + 1. 
							(next + cInteger) <= aArray size ifTrue:[ next _ next + cInteger ]
															ifFalse:[next _ aArray size].
												].
							list add: row.
						
						].
		self contents: list.! !

!Table methodsFor: 'initialization' stamp: 'AK 1/18/2000 23:32'!
initialize
	"initializes the receiver"
		
	self contents: (OrderedCollection with: OrderedCollection new).
	transposed _ false.
	! !


!Table class methodsFor: 'Example1' stamp: 'AK 1/19/2000 02:02'!
example1

		| aArray tab |
		aArray _ #( 'A' 'B' 'C' 1 2 3 'O' 'P' 'Q').
		tab _ Table new.
		tab adaptArrayToTable: aArray columns: 3 rows: 3.
		" Table example1"
		! !

!Table class methodsFor: 'instance creation' stamp: 'AK 1/19/2000 02:03'!
new
	^ super new initialize.
	! !


!TableMorph methodsFor: 'geometry' stamp: 'AK 2/16/2000 20:31'!
fullBounds

	
	fullBounds ifNil: [
		self resizeIfNeeded.
		self fixLayout.
		super fullBounds.  
		priorFullBounds == nil
			ifTrue: [self invalidRect: fullBounds]
			ifFalse: [fullBounds = priorFullBounds
					ifFalse: ["report change due to layout"
							self invalidRect: (fullBounds merge: priorFullBounds)]].
		layoutNeeded _ false].
	^ super fullBounds
! !

!TableMorph methodsFor: 'geometry' stamp: 'AK 2/16/2000 20:34'!
layoutChanged

	layoutNeeded ifTrue: [^ self].  
	layoutNeeded _ true.
	priorFullBounds _ fullBounds.  
	super layoutChanged.
! !

!TableMorph methodsFor: 'geometry' stamp: 'AK 2/16/2000 20:31'!
minHeight
		| heightlist mheight lineY |
		rowGrid ifTrue:[lineY _ line] ifFalse:[lineY _ 0].
		heightlist _ self rowHeightList.
		mheight _ (2*borderWidth) + (2*inset).
		heightlist isEmpty ifTrue:[ mheight _ mheight + minSize]
			ifFalse:[ heightlist do:[:h | mheight _ mheight + (2*pady) + lineY + h].
					 mheight _ mheight + lineY].
		^mheight! !

!TableMorph methodsFor: 'geometry' stamp: 'AK 2/16/2000 20:31'!
minWidth
		| widthlist mwidth lineX |
		colGrid ifTrue:[lineX _ line] ifFalse:[lineX _ 0].
		widthlist _ self columnWidthList.
		mwidth _ (2*borderWidth) + (2*inset).
		widthlist isEmpty ifTrue:[ mwidth _ mwidth + minSize]
						ifFalse:[ widthlist do:[:w |
										mwidth _ mwidth + (2*padx) + lineX + w].
								 mwidth _ mwidth + lineX ].
		^mwidth.
		
		! !

!TableMorph methodsFor: 'drawing' stamp: 'AK 2/9/2000 02:12'!
drawOn: aCanvas
		super drawOn: aCanvas.
		self drawGrid: aCanvas.! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/14/2000 23:54'!
columnWidthList
	| columnList col colSize max |	
	table hasElement ifTrue:[
			
			colSize _ table numberOfColumns.
			columnList _ Array new: colSize.
			1 to: colSize do:[:i | max _ 0. 
							col _ table columnAt: i.
							col do:[: m | m ifNil:[ max < minSize ifTrue:[max _ minSize]]
									       ifNotNil:[ max < m fullBounds width ifTrue:[max _ (m fullBounds width) max: minSize]]].
							columnList at: i put: max.
							]
	] ifFalse:[columnList _ Array new].
	^columnList! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/16/2000 20:30'!
drawGrid: aCanvas

	| colList rowList startCp endCp startRp endRp x y offset lineback |
	lineback _ line//2.
	offset _ line - lineback.
	" draw column grid "
	colGrid ifTrue:[
		colList _ self columnWidthList.
		startCp _ self innerBounds origin + inset +(lineback@lineback).
		endCp _ (self innerBounds left + inset + lineback)@(self innerBounds bottom - inset - 1).
		table hasElement ifTrue:[aCanvas line: startCp to: endCp width: line color: lineColor].
		startCp _ startCp + (offset@0).
		endCp _ endCp + (offset@0).
		colList do:[:w |   x _ (2*padx) + w + lineback.
						startCp _ startCp + (x @ 0).
						endCp _ endCp +( x @ 0).
						aCanvas line: startCp to: endCp width: line color: lineColor.
						startCp _ startCp + (offset@0).
						endCp _ endCp +( offset @ 0).
						]
	].
	" draw row grid "
	rowGrid ifTrue:[
		rowList _ self rowHeightList.
		startRp _ self innerBounds origin + inset + (lineback@lineback).
		endRp _ (self innerBounds right - inset - 1) @ (self innerBounds top + inset +lineback).
		table hasElement ifTrue:[aCanvas line: startRp to: endRp width: line color: lineColor].
		startRp _ startRp + (0 @ offset).
		endRp _  endRp + (0 @ offset).
		rowList do:[:h | y _ (2*pady) + h + lineback.
						startRp _ startRp + (0 @ y).
						endRp _  endRp + (0 @ y).
						aCanvas line: startRp to: endRp width: line color: lineColor.
						startRp _ startRp + (0 @ offset).
						endRp _  endRp + (0 @ offset).
						]
	
	]	
	  
	
! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/16/2000 20:29'!
fixLayout
	| r c rowHeights colWidths morphs morph morphList nextPlace nextHeight rheight cwidth 	lineX lineY |
	table hasElement ifFalse:[ ^self ].
	rowGrid ifTrue:[lineY _ line] ifFalse:[lineY _ 0].
	colGrid ifTrue:[lineX _ line] ifFalse:[lineX _ 0].
	r _ table numberOfRows.
	c _ table numberOfColumns.
	rowHeights _ self rowHeightList.
	colWidths _ self columnWidthList.
	nextHeight _ bounds top + borderWidth + inset + lineY + pady.
	morphList _ Array new.
	1 to: r do:[:i | morphs _ OrderedCollection new.
				nextPlace _ bounds left + borderWidth + inset + lineX + padx.
				rheight _ (rowHeights at: i) max: minSize.
				1 to: c do:[:col | cwidth _ colWidths at: col.
					morph _ table at: col@i.
					morph ifNotNil:[
						morphs add: (self setPositionFor: morph place: nextPlace row: nextHeight width: cwidth height: rheight)
						].
					nextPlace _ nextPlace + cwidth + (2*padx) + lineX.
					].
				nextHeight _ nextHeight + (2*pady) + lineY + rheight.
				morphList _ morphList, morphs.
				].
	 
	self addAllMorphs: morphList.	! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/15/2000 06:56'!
insertionColPositionFor: aMorph
	| newCenter col width lineX |
	newCenter _ aMorph fullBounds center.
	colGrid ifTrue:[lineX _ line] ifFalse:[lineX _ 0].
	col _ self columnWidthList.
	col	 isEmpty ifTrue:[^1].
	width _ bounds left + borderWidth + (inset*2).
	col doWithIndex:[:w :index |
					width _ width + w.
					newCenter x < width ifTrue:[ ^index].
					width _ width + lineX].

					! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/15/2000 06:56'!
insertionRowPositionFor: aMorph
	| newCenter row height lineY|
	newCenter _ aMorph fullBounds center.
	rowGrid ifTrue:[lineY _ line] ifFalse:[lineY _ 0].
	row _ self rowHeightList.
	row	 isEmpty ifTrue:[^1].
	height _ bounds top + borderWidth + (inset*2).
	row doWithIndex:[:h :index |
					height _ height + h.
					newCenter y < height ifTrue:[ ^index].
					height _ height + lineY].

					! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/15/2000 03:26'!
privateRemoveMorph: aMorph

		super privateRemoveMorph: aMorph.
		table removeObject: aMorph.! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/8/2000 02:32'!
resizeIfNeeded
		| newWidth newHeight |
		newWidth _ (self minWidth) max: minSize.
		newHeight _ (self minHeight) max: minSize.
	
		((newWidth ~= bounds width) or: [newHeight ~= bounds height])
		ifTrue: ["bounds really changed"
				bounds _ bounds origin extent: newWidth@newHeight].
! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/14/2000 23:55'!
rowHeightList
		| rowList max row rowSize |
		table hasElement ifTrue:[
				
				rowSize _ table numberOfRows.
				rowList _ Array new: rowSize.
				1 to: rowSize do:[:i | max _ 0.
								row _ table rowAt: i.
								row do:[:m | m isNil ifTrue:[max < minSize ifTrue:[max _ minSize]]
											         ifFalse:[max < m fullBounds height ifTrue:[ max _ (m fullBounds height) max: minSize]]].
								rowList at: i put: max.
								]
		] ifFalse:[ rowList _ Array new].
		^rowList! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/16/2000 21:47'!
setPositionFor: aMorph place: nextPlace row: nextHeight width: aWidth height: aHeight

	| left top fullBnd morph |
	fullBnd _ aMorph fullBounds.
	morph _ aMorph.
	self centering == #center ifTrue:[
						left _ nextPlace + ((aWidth - fullBnd width) // 2).
						top _ nextHeight + (( aHeight - fullBnd height) // 2)].
	self centering == #left ifTrue:[
						left _ nextPlace.
						top _ nextHeight + ((aHeight - fullBnd height) // 2).].
	self centering == #right ifTrue:[
						left _ nextPlace + (aWidth - fullBnd width).
						top _ nextHeight + ((aHeight - fullBnd height) // 2)].
	self centering == #fill ifTrue:[
						left _ nextPlace.
						top _ nextHeight.
						morph extent: aWidth@aHeight
						].
	^morph position: left@top! !

!TableMorph methodsFor: 'private' stamp: 'AK 2/9/2000 04:30'!
showGrid: aSymbol

		aSymbol == #rowgrid ifTrue:[rowGrid _ true. colGrid _ false].
		aSymbol == #colgrid ifTrue:[rowGrid _ false. colGrid _ true].
		aSymbol == #bother ifTrue:[rowGrid _ true. colGrid _ true].
		aSymbol == #none ifTrue:[rowGrid _ false. colGrid _ false].
		self layoutChanged.! !

!TableMorph methodsFor: 'dropping/grabbing' stamp: 'AK 2/18/2000 05:50'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add morphs just by dropping them on the table."
	aMorph owner privateRemoveMorph: aMorph.
	self addMorphFront: aMorph.
	
! !

!TableMorph methodsFor: 'dropping/grabbing' stamp: 'AK 2/18/2000 03:23'!
allowSubmorphExtraction

	^ openToDragNDrop
! !

!TableMorph methodsFor: 'dropping/grabbing' stamp: 'AK 2/18/2000 03:00'!
wantsDroppedMorph: aMorph event: evt
	"Supports adding morphs by dropping."

	^ openToDragNDrop! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/15/2000 04:53'!
addColumn: aMorph
	| column |
	column _ OrderedCollection with: aMorph.
	table addColumn: column.
	self changed.
	self layoutChanged.! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/15/2000 04:53'!
addRow: aMorph
	| row |
	row _ OrderedCollection with: aMorph.
	table addRow: row.
	self changed.
	self layoutChanged.! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/8/2000 00:04'!
centering

	^centering ! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/8/2000 00:03'!
centering: aSymbol

	centering _ aSymbol.! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/18/2000 02:01'!
chooseOrientation
	| aMenu emphases reply |
	emphases _ #(vertical horizontal).
	aMenu _ EmphasizedMenu selections: emphases.
	aMenu onlyBoldItem: (emphases indexOf: orientation).
	reply _ aMenu startUpWithCaption: 'Choose orientation'.
	(reply == nil or: [reply == orientation]) ifTrue: [^ self].
	self orientation: reply.
	self layoutChanged	! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/9/2000 04:31'!
chooseShowGrid
	| aMenu reply |
	aMenu _ SelectionMenu selections: #(rowgrid colgrid bother none).
	reply _ aMenu startUpWithCaption:'Show grid'.
	reply == nil ifTrue: [ ^self].
	self showGrid: reply.
	 ! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/8/2000 00:04'!
inset

	^inset ! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/8/2000 00:04'!
inset: aInteger

	inset _ aInteger ! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/8/2000 00:02'!
line
	^line! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/8/2000 00:03'!
line: aInteger

	line _ aInteger.! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/18/2000 02:49'!
openCloseDragNDrop
	"Toggle this morph's ability to add and remove morphs via drag-n-drop."

	openToDragNDrop _ openToDragNDrop not.
! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/18/2000 02:50'!
openToDragNDrop
	
	^openToDragNDrop! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/18/2000 02:50'!
openToDragNDrop: aBoolean
	
	openToDragNDrop _ aBoolean.! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/18/2000 02:02'!
orientation
	^orientation ! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/18/2000 02:15'!
orientation: aSymbol
	orientation _ aSymbol.
	orientation == #vertical ifTrue:[table transposed: true. table changed].
	orientation == #horizontal ifTrue:[table transposed: false . table changed].
	self changed.! !

!TableMorph methodsFor: 'accessing' stamp: 'AK 2/14/2000 23:07'!
putCell: aMorph
	| row col |
	row _ self insertionRowPositionFor: aMorph. 
	col _ self insertionColPositionFor: aMorph. 
	self removeMorph:(table at: col@row).
	table at: (col @ row) put: aMorph.
	self changed.
	self layoutChanged.
	
		! !

!TableMorph methodsFor: 'submorphs-add/remove' stamp: 'AK 2/15/2000 03:30'!
addAllMorphs: aCollection

	aCollection do: [:m |
		m owner ifNotNil: [ m changed.
							m owner privateSubmorphs: ((m owner) submorphs copyWithout: m)].
		m layoutChanged.
		m privateOwner: self].
	submorphs _ submorphs, aCollection.
	self layoutChanged.
! !

!TableMorph methodsFor: 'submorphs-add/remove' stamp: 'AK 2/18/2000 02:59'!
addMorphFront: aMorph
	| aMenu reply |
	aMenu _ SelectionMenu selections: #(addColumn addRow putCell).
	reply _ aMenu startUpWithCaption:'How to added'.
	reply == nil ifTrue: [ ^self].
	reply == #addColumn ifTrue:[ self addColumn: aMorph].
	reply == #addRow ifTrue:[ self addRow: aMorph].
	reply == #putCell ifTrue:[ self putCell: aMorph].
	self changed.
	self layoutChanged.  ! !

!TableMorph methodsFor: 'submorphs-add/remove' stamp: 'AK 2/14/2000 23:05'!
removeMorph: aMorph

	aMorph changed.
	submorphs _ submorphs copyWithout: aMorph.
	self layoutChanged.
! !

!TableMorph methodsFor: 'initialization' stamp: 'AK 2/18/2000 02:49'!
initialize	
	super initialize.
	borderColor  _ Color black.
	color _ Color white.
	borderWidth _ 3.
	layoutNeeded _ true.
	inset _ 4.
	padx _ 2.	" pading of "
	pady _ 2.
	centering _ #fill.
	minSize _ 30.
	line _ 1.
	lineColor _ Color blue.
	rowGrid _ false.
	colGrid _ false.
	orientation _ #horizontal.
	openToDragNDrop _ false.
	table _ Table new.! !

!TableMorph methodsFor: 'menu' stamp: 'AK 2/18/2000 03:15'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'orientation...' action: #chooseOrientation.
	aCustomMenu add: 'show grid...' action: #chooseShowGrid.
	aCustomMenu add: (self openToDragNDrop ifTrue: ['close dragNdrop'] ifFalse: ['open dragNdrop']) action: #openCloseDragNDrop.! !


!TableMorph class methodsFor: 'testing' stamp: 'AK 2/4/2000 01:53'!
test

	self new openInWorld.! !


TableMorph removeSelector: #rootForGrabOf:!
