'From Squeak 2.5 of August 6, 1999 on 8 November 1999 at 5:03:08 pm'!
"Change Set:		TTF2Strike
Date:			8 November 1999
Author:			Hans-Martin Mosner & Rob Vens

This small set of methods add the facility to translate TTF fonts into antialiased StrikeFonts.
There are a number of glitches:
1. I don't know exactly how to translate from point sizes to TrueType's scaling units. From experimentation, scaling points by 1/2000 seems to do the trick. YMMV.
2. The generated fonts are FormSetFonts where the glyphs were antialiased against a white background. This means that text written with it can't be colored, and that the edges look strange against darker backgrounds.
3. Glyphs which overshoot their bounding box are clipped. That's just how StrikeFonts work. I did not want to meddle with the whole mechanisms of text display.

Hans-Martin"!


!TTFontDescription methodsFor: 'converting' stamp: 'hmm 11/8/1999 11:15'!
asStrikeFontScale: scale
	| forms |
	"Generate a StrikeFont (actually a FormSetFont) for this TTF font at a given size"
	forms _ (0 to: 255) collect: [:i |
		(self at: i)
			asFormWithScale: scale
			ascender: ascender
			descender: descender].
	^FormSetFont new
		fromFormArray: forms
		asciiStart: 0
		ascent: (ascender * scale) rounded! !


!TTFontReader class methodsFor: 'instance creation' stamp: 'hmm 11/8/1999 11:43'!
installTTF: ttfFileName asTextStyle: textStyleName sizes: sizeArray
	| ttf fontArray |
	"TTFontReader installTTF: 'c:\os2\mdos\winos2\system\arial.ttf' asTextStyle: #Arial sizes: #(10 12 14 18 24)"
	ttf _ self parseFileNamed: ttfFileName.
	fontArray _ sizeArray collect: [:s |
		ttf asStrikeFontScale: s/2000.0].
	TextConstants at: textStyleName asSymbol put: (TextStyle fontArray: fontArray)! !


!TTGlyph methodsFor: 'converting' stamp: 'hmm 11/8/1999 13:16'!
asFormWithScale: scale ascender: ascender descender: descender
	| form canvas |
	form _ Form extent: (advanceWidth @ (ascender - descender) * scale) rounded depth: 8.
	form fillWhite.
	canvas _ BalloonCanvas on: form.
	canvas aaLevel: 3.
	canvas transformBy: (MatrixTransform2x3 withScale: scale asPoint * (1@-1)).
	canvas transformBy: (MatrixTransform2x3 withOffset: 0@ascender negated).
	canvas
		drawGeneralBezierShape: self contours
		color: Color black 
		borderWidth: 0 
		borderColor: Color black.
	form replaceColor: Color white withColor: Color transparent.
	^form! !


